#version 120
#extension GL_EXT_gpu_shader3 : enable

uniform int fogMode;
uniform int dissolveMode;

uniform vec2 ensembleParamA;
uniform float ensembleParamB;
uniform vec2 ensembleParamC;

uniform float projInv11;
uniform float projInv15;

varying vec3 position;
varying vec4 color;

//##FUNC_SMOOTHCLIPPING##

void EnsembleDithering(inout float alpha){
    if (dissolveMode >= 1){
	float bound = 0.015;
	if (dissolveMode == 2) bound = 1;
	
	if (alpha <= bound){
	    float crit = fract(sin(dot(gl_FragCoord.xy + position.xz + ensembleParamA ,
				       ensembleParamC)) * ensembleParamB) * bound;
	    
	    if (alpha <= crit) discard;
	    else alpha = bound;
	}
    }
}

//##FUNC_FOG_EFFECT##

void main (void)
{
    float alpha = color[3];//gl_FrontLightProduct[0].ambient[3];

    //##APPLY_SMOOTHCLIPPING##
    
    //##APPLY_ENSEMBLE_DITHERING##

    if (alpha > 1.0) alpha = 1.0;
    
    gl_FragColor = color;

    FogEffect();

    gl_FragColor[3] = alpha;
}
